﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using GameEngine.LevelGeneration;
using GameEngine.Xml;
using GameEngine;

namespace Editor.Editor
{
    public partial class NewLevelTile : Form
    {
        public TileType TileType { get; private set; }
        public string TileName { get; private set; }
        public TilesetNode Tileset { get; set; }

        public NewLevelTile()
        {
            InitializeComponent();

            cmbTileset.Items.AddRange(TilesetManager.TileSets.ToArray());
            cmbTileset.SelectedIndex = 0;

            foreach (TileType t in Enum.GetValues(typeof(TileType)))
            {
                cmbTileType.Items.Add(t);
            }

            cmbTileType.SelectedIndex = cmbTileType.Items.IndexOf(TileInfoNode.DefaultTileType);
            txtTileName.Text = "Untitled Tile";

            this.FormClosing += new FormClosingEventHandler(NewLevelTile_FormClosing);
        }

        void NewLevelTile_FormClosing(object sender, FormClosingEventArgs e)
        {
            Tileset = cmbTileset.SelectedItem as TilesetNode;
            TileName = txtTileName.Text;
            TileType = (TileType)cmbTileType.SelectedItem;
        }

    }
}
