using System;
using System.Collections.Generic;
using System.Text;
using GameEngine.Objects;
using Editor.Data;
using Microsoft.Xna.Framework;
using GameEngine.Data;

namespace Editor
{
    public class PhysicsPropStub : GameObject
    {
        private float mass = 1;

        public float Mass
        {
            get { return mass; }
            set { mass = value; }
        }

        private PhysicsPropData data;

        public PhysicsPropData Data
        {
            get { return data; }
            set { data = value; }
        }



        private List<StaticProp> staticProp = new List<StaticProp>();

        public List<StaticProp> StaticProp
        {
            get { return staticProp; }
            set { staticProp = value; }
        }

        private List<PhysicsPolygon> polygons = new List<PhysicsPolygon>();

        public List<PhysicsPolygon> Polygons
        {
            get { return polygons; }
            set { polygons = value; }
        }

        public PhysicsPropStub()
        {
        }

        Matrix w;
        public override void Update(Microsoft.Xna.Framework.GameTime time)
        {
            this.Rotation = Quaternion.Identity;
            w = Matrix.CreateScale(Scale) * Matrix.CreateFromQuaternion(Rotation) * Matrix.CreateTranslation(Position) * parentMatrix;

            foreach (StaticProp prop in staticProp)
            {
                prop.parentMatrix = w;
                prop.Update(time);
            }
            foreach (PhysicsPolygon pp in polygons)
            {
                pp.parentMatrix = w;
            }
            
            base.Update(time);
        }

        public override void Draw(GameTime time, GameEngine.DrawInfo renderer)
        {
            foreach (StaticProp prop in staticProp)
            {
                prop.Draw(time, renderer);
            }
            foreach (PhysicsPolygon pp in polygons)
            {
                pp.Draw(renderer);
            }
            base.Draw(time, renderer);
        }

    }
}
