﻿using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework.Content.Pipeline.Serialization.Compiler;
using GameEngine.Animation;
using Microsoft.Xna.Framework;

namespace GameContentPipeline
{
    [ContentTypeWriter]
    public class AnimationDataWriter : ContentTypeWriter<AnimationData>
    {
        protected override void Write(ContentWriter output, AnimationData value)
        {
            output.Write(value.Skinned);
            output.WriteObject(value.Tracks);

            if (value.Skinned)
            {
                output.WriteObject(value.BindPoses);
                output.WriteObject(value.InverseBindPoses);
                output.WriteObject(value.SkeletonHierarchy);
                output.WriteObject(value.BoneMap);
                output.WriteObject(value.ModelBoneToSkinMap);
            }
        }

        public override string GetRuntimeReader(TargetPlatform targetPlatform)
        {
            return typeof(AnimationDataReader).AssemblyQualifiedName;
        }        
    }

    [ContentTypeWriter]
    public class AnimationTrackWriter : ContentTypeWriter<AnimationTrack>
    {
        protected override void Write(ContentWriter output, AnimationTrack value)
        {
            output.WriteObject(value.Duration);
            output.WriteObject(value.Keyframes);
        }

        public override string GetRuntimeReader(TargetPlatform targetPlatform)
        {
            return typeof(AnimationTrackReader).AssemblyQualifiedName;
        }
    }

    [ContentTypeWriter]
    public class KeyframeWriter : ContentTypeWriter<Keyframe>
    {
        protected override void Write(ContentWriter output, Keyframe value)
        {
            output.WriteObject(value.Bone);
            output.WriteObject(value.Time);
            output.WriteObject(value.Transform);
        }

        public override string GetRuntimeReader(TargetPlatform targetPlatform)
        {
            return typeof(KeyframeReader).AssemblyQualifiedName;
        }
    }
}
