using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework.Content.Pipeline.Processors;
using Microsoft.Xna.Framework.Content.Pipeline;
using Microsoft.Xna.Framework.Content.Pipeline.Serialization.Compiler;
using GameEngine.Data.Content;
using Microsoft.Xna.Framework;
using GameEngine.Data;

namespace GameContentPipeline
{
    /*public class SceneContent
    {
        public List<StaticPropContent> staticProps = new List<StaticPropContent>();
        public List<PhysicsPolygonData> polygons = new List<PhysicsPolygonData>();
    }

    public class StaticPropContent
    {
        public Vector3 Position, Scale;
        public Quaternion Rotation;
        public ExternalReference<ModelContent> Model;
        public StaticPropContent(ExternalReference<ModelContent> model, StaticPropData staticProp)
        {
            this.Model = model;
            this.Position = staticProp.Position;
            this.Rotation = staticProp.Rotation;
            this.Scale = staticProp.Scale;
        }
    }*/

    [ContentTypeWriter]
    public class SceneContentTypeWriter : ContentTypeWriter<SceneData>
    {
        protected override void Write(ContentWriter output, SceneData value)
        {
            output.WriteObject(value.StaticProps);
            output.WriteObject(value.PhysicsPolygons);
        }

        public override string GetRuntimeReader(Microsoft.Xna.Framework.TargetPlatform targetPlatform)
        {
            return typeof(SceneReader).AssemblyQualifiedName;
        }
    }

    
    [ContentTypeWriter]
    public class StaticPropContentTypeWriter : ContentTypeWriter<StaticPropData>
    {
        protected override void Write(ContentWriter output, StaticPropData value)
        {
            output.Write(value.Asset);
            output.Write(value.ID);
            output.Write(value.Position);
            output.Write(value.Rotation);
            output.Write(value.Scale);
        }

        public override string GetRuntimeReader(Microsoft.Xna.Framework.TargetPlatform targetPlatform)
        {
            return typeof(StaticPropReader).AssemblyQualifiedName;
        }
    }

    [ContentTypeWriter]
    public class PhysicsPolygonTypeWriter : ContentTypeWriter<PhysicsPolygonData>
    {
        protected override void Write(ContentWriter output, PhysicsPolygonData value)
        {
            output.Write(value.ID);
            output.WriteObject(value.Points);
        }

        public override string GetRuntimeReader(Microsoft.Xna.Framework.TargetPlatform targetPlatform)
        {
            return typeof(PhysicsPolygonReader).AssemblyQualifiedName;
        }
    }

}
