using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Content.Pipeline;
using Microsoft.Xna.Framework.Content.Pipeline.Graphics;
using Microsoft.Xna.Framework.Content.Pipeline.Processors;

using GameEngine.Data;
using BinarySerialization;
using System.Runtime.Serialization.Formatters.Binary;
using System.IO;
using System.Runtime.Serialization.Formatters;

namespace GameContentPipeline
{

    [ContentImporter(".lvl", DisplayName = "SP1 - SceneImporter")]
    public class ZigImporter : ContentImporter<SceneData>
    {
        public override SceneData Import(string filename, ContentImporterContext context)
        {
            BinaryFormatter bf = new BinaryFormatter();
            bf.AssemblyFormat = FormatterAssemblyStyle.Simple;
            bf.Binder = new Binder();
            SceneData lvl;
            using (FileStream fs = File.OpenRead(filename))
                lvl = (SceneData)bf.Deserialize(fs);

            /*for (int i = 0; i < lvl.StaticProps.Count; i++)
            {
                lvl.StaticProps[i].Asset = Path.Combine(Path.GetDirectoryName(filename), lvl.StaticProps[i].Asset);
                
                context.AddDependency(lvl.StaticProps[i].Asset);
            }*/
            return lvl;
        }
    }
    /*
    [ContentProcessor(DisplayName = "SP1 - SceneImporter")]
    public class StaticPropProcessor : ContentProcessor<SceneData, SceneContent>
    {
        public override SceneContent Process(SceneData input, ContentProcessorContext context)
        {
            SceneContent sceneContent = new SceneContent();
            foreach (StaticPropData staticProp in input.StaticProps)
            {
                ExternalReference<NodeContent> model = new ExternalReference<NodeContent>(staticProp.Asset);

                sceneContent.staticProps.Add(new StaticPropContent(context.BuildAsset<NodeContent, ModelContent>(model, null), staticProp));
            }
            foreach (PhysicsPolygonData data in input.PhysicsPolygons)
            {
                sceneContent.polygons.Add(data);
            }
            return sceneContent;
        }
    }*/


}