﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace GameEngine.ScreenSystem
{
    public static class GUIhelper
    {
        public static float GetHorisontalCenter(string text, SpriteFont spriteFont, Game game, float scale)
        {
            return game.Window.ClientBounds.Width / 2 - (spriteFont.MeasureString(text).X * scale) / 2;
        }

        public static float GetHorisontalCenter(string text, SpriteFont spriteFont, GraphicsDevice graphics, float scale)
        {
            return graphics.Viewport.Width / 2 - (spriteFont.MeasureString(text).X * scale) / 2;
        }
        
        public static float GetVerticalCenter(string text, SpriteFont spriteFont, Game game, float scale)
        {
            return game.Window.ClientBounds.Height / 2 - (spriteFont.MeasureString(text).Y * scale) / 2;
        }
    }
}
