using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;

namespace GameEngine.ScreenSystem
{
    public abstract class GameScreen
    {
        public string ID { get; private set; }
        protected Game Game { get; set; }
        protected ScreenController controller;
        protected ContentManager content;
        
        public GameScreen(string id, ScreenController controller, Game game)
        {
            this.ID = id;
            this.controller = controller;
            this.Game = game;

            this.content = new ContentManager(game.Services);
            this.content.RootDirectory = "Content";
        }

        public abstract void LoadContent(GraphicsDeviceManager graphics);
        public abstract void Initialize(GraphicsDevice graphics);
        public void UnloadContent() { this.content.Unload(); }
        public abstract void Update(GameTime gameTime);
        public abstract void Draw(GameTime gameTime, GraphicsDevice graphics, SpriteBatch spriteBatch, SpriteFont spriteFont);
    }
}
