﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework.Graphics;

namespace GameEngine.TextureGeneration
{
    public enum BloodAmount
    {
        FourLiter,
        TwoLiter,
        OneLiter,
        HalfLiter,
        QuarterLiter,
        OneDeciliter
    }

    public class BloodTextures
    {
        private BloodGenerator bg;

        private Texture2D[] fourLiter;
        private Texture2D[] twoLiter;
        private Texture2D[] oneLiter;
        public Texture2D[] halfLiter;
        private Texture2D[] quarterLiter;
        private Texture2D[] oneDeciliter;

        public BloodTextures(GraphicsDevice gd)
        {
            bg = new BloodGenerator(gd);
        }

        public void GenerateTextures(int fourLiter, int twoLiter, int oneLiter, int halfLiter, int quarterLiter, int oneDeciliter)
        {
            this.fourLiter = new Texture2D[fourLiter];
            bg.LiquidAmount = 4000;
            for (int i = 0; i < fourLiter; i++)
            {
                bg.Generate();
                this.fourLiter[i] = bg.GetTexture();
            }

            this.twoLiter = new Texture2D[twoLiter];
            bg.LiquidAmount = 2000;
            for (int i = 0; i < twoLiter; i++)
            {
                bg.Generate();
                this.twoLiter[i] = bg.GetTexture();
            }

            this.oneLiter = new Texture2D[oneLiter];
            bg.LiquidAmount = 1000;
            for (int i = 0; i < oneLiter; i++)
            {
                bg.Generate();
                this.oneLiter[i] = bg.GetTexture();
            }

            this.halfLiter = new Texture2D[halfLiter];
            bg.LiquidAmount = 750;
            for (int i = 0; i < halfLiter; i++)
            {
                bg.Generate();
                this.halfLiter[i] = bg.GetTexture();
            }

            this.quarterLiter = new Texture2D[quarterLiter];
            bg.LiquidAmount = 250;
            for (int i = 0; i < quarterLiter; i++)
            {
                bg.Generate();
                this.halfLiter[i] = bg.GetTexture();
            }

            this.oneDeciliter = new Texture2D[oneDeciliter];
            bg.LiquidAmount = 100;
            for (int i = 0; i < oneDeciliter; i++)
            {
                bg.Generate();
                this.oneDeciliter[i] = bg.GetTexture();
            }
        }

        public Texture2D GetRandomTexture(BloodAmount amount)
        {
            Texture2D theTexture;
            switch (amount)
            {
                case BloodAmount.FourLiter:
                    theTexture = this.fourLiter[Util.Random.Next(0, this.fourLiter.Length - 1)];
                    break;
                case BloodAmount.TwoLiter:
                    theTexture = this.twoLiter[Util.Random.Next(0, this.twoLiter.Length - 1)];
                    break;
                case BloodAmount.OneLiter:
                    theTexture = this.oneLiter[Util.Random.Next(0, this.oneLiter.Length - 1)];
                    break;
                case BloodAmount.HalfLiter:
                    theTexture = this.halfLiter[Util.Random.Next(0, this.halfLiter.Length - 1)];
                    break;
                case BloodAmount.QuarterLiter:
                    theTexture = this.quarterLiter[Util.Random.Next(0, this.quarterLiter.Length - 1)];
                    break;
                case BloodAmount.OneDeciliter:
                default:
                    theTexture = this.oneDeciliter[Util.Random.Next(0, this.oneDeciliter.Length - 1)];
                    break;
            }
            return theTexture;
        }
    }
}
