using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using System.Xml;
using System.Reflection;
using Microsoft.Xna.Framework.Content;
using System.IO;

namespace GameEngine.Xml
{
    public class XmlTest
    {
        public static event EventHandler<NodeLoadEventArgs> NodeLoaded;
        public static event EventHandler<NodeLoadEventArgs> BeforeNodeChildrenLoaded;
        public class NodeLoadEventArgs : EventArgs { public SceneNode Node; }

        //public static string testFile = @"c:\Documents and Settings\FeLiZk\Desktop\Sp1\kode\SP1Project\GamePrototype\Content\test.xml";
        //public static string testFile2 = @"c:\Documents and Settings\FeLiZk\Desktop\Sp1\kode\SP1Project\GamePrototype\Content\physObj.xml";
        public static void Test()
        {
           /* PhysObjectNode node = new PhysObjectNode("physicsSandStone");
            node.Mass = 1f;

            PhysPolyNode geom = new PhysPolyNode("geom");
            geom.Friction = 0.1f;
            geom.Restitution = 0.1f;
            geom.Points.Add(new Vector2(-10, -10));
            geom.Points.Add(new Vector2(-10, 10));
            geom.Points.Add(new Vector2(10, 10));
            geom.Points.Add(new Vector2(10, -10));
            node.ChildNodes.Add(geom);

            ModelNode asset = new ModelNode("model");
            asset.Asset = @"Models\sandstone\sandstone";
            asset.Position = new Vector3(0, -10, 0);
            asset.Scale = new Vector3(0.2f, 0.2f, 0.2f);
            node.ChildNodes.Add(asset);

            XmlDocument physObj = XmlHelper.CreateDocument(new SceneNode[] { node });
            physObj.Save(testFile2);





            
            SceneNode rootNode = new SceneNode("Root");
            PhysicsSimulationNode simulatorNode = new PhysicsSimulationNode("Simulator");
            simulatorNode.Gravity = new Vector2(0, -30);
            rootNode.ChildNodes.Add(simulatorNode);

            ObjectNode obj1 = new ObjectNode("Obj1");
            obj1.Position = new Microsoft.Xna.Framework.Vector3(1, 2, 3);
            obj1.Scale = new Microsoft.Xna.Framework.Vector3(3, 2, 1);
            obj1.Rotation = Quaternion.Identity;
            rootNode.ChildNodes.Add(obj1);

            ObjectNode obj2 = new ObjectNode("Obj2");
            obj2.Position = new Microsoft.Xna.Framework.Vector3(1, 2, 3);
            obj2.Scale = new Microsoft.Xna.Framework.Vector3(3, 2, 1);
            obj2.Rotation = Quaternion.Identity;
            obj1.ChildNodes.Add(obj2);

            PhysObjectNode pNode = new PhysObjectNode("someObject");
            pNode.Include = testFile2;
            pNode.Mass = 1f;
            pNode.SimulatorNode = simulatorNode.Path;
            pNode.Position = new Vector3(-50, 100, 0);
            rootNode.ChildNodes.Add(pNode);

            pNode = new PhysObjectNode("someObject2");
            pNode.SimulatorNode = simulatorNode.Path;
            pNode.Include = testFile2;
            pNode.Mass = 1f;
            pNode.Position = new Vector3(50, 100, 0);
            rootNode.ChildNodes.Add(pNode);

            ModelNode assetNode = new ModelNode("StaticProp1");
            assetNode.Position = new Vector3(0, 100, 0);
            assetNode.Scale = new Vector3(1f);
            assetNode.Asset = @"Models\sandstone\sandstone";
            rootNode.ChildNodes.Add(assetNode);

            PhysObjectNode earth = new PhysObjectNode("earth");
            earth.Mass = 1f;
            earth.IsStatic = true;

            earth.SimulatorNode = simulatorNode.Path;

            geom = new PhysPolyNode("geom");
            geom.Friction = 0.1f;
            geom.Restitution = 0.1f;
            geom.Points.Add(new Vector2(-100, -10));
            geom.Points.Add(new Vector2(-100, 10));
            geom.Points.Add(new Vector2(100, 10));
            geom.Points.Add(new Vector2(100, -10));
            earth.ChildNodes.Add(geom);

            asset = new ModelNode("model");
            asset.Asset = @"Models\sandstone\sandstone";
            asset.Position = new Vector3(0, -10, 0);
            asset.Scale = new Vector3(2f, 0.2f, 0.2f);
            earth.ChildNodes.Add(asset);

            rootNode.ChildNodes.Add(earth);

            XmlDocument doc = XmlHelper.CreateDocument(new SceneNode[] { rootNode });
            doc.Save(testFile);
*/
            

        }


        public static List<SceneNode> LoadTest(XmlDocument loadDoc, string file)
        {
            List<SceneNode> nodes = new List<SceneNode>();

            foreach (XmlNode element in loadDoc.DocumentElement.ChildNodes)
            {
                if (!(element is XmlElement))
                    continue;

                SceneNode node = LoadUsingReflection(null, (XmlElement)element, file, null);
                if (node != null)
                    nodes.Add(node);
            }
            return nodes;
        }

        public static NodeList LoadScene(XmlDocument loadDoc)
        {
            NodeList nodes = new NodeList(null);
            LoadUsingReflection(nodes, loadDoc.DocumentElement.ChildNodes);
            return nodes;
        }


        public static List<SceneNode> LoadTest(XmlDocument loadDoc)
        {
            return LoadTest(loadDoc, null);
        }

        public static List<SceneNode> LoadTest(string file)
        {
            XmlDocument loadDoc = new XmlDocument();
            loadDoc.Load(file);
            return LoadTest(loadDoc, file);
        }

        public static List<SceneNode> LoadTest(string asset, ContentManager content)
        {
            XmlDocument loadDoc = content.Load<XmlDocument>(asset);

            List<SceneNode> nodes = new List<SceneNode>();

            foreach (XmlNode element in loadDoc.DocumentElement.ChildNodes)
            {
                if (!(element is XmlElement))
                    continue;

                SceneNode node = LoadUsingReflection(null, (XmlElement)element, asset, content);
                if (node != null)
                    nodes.Add(node);
            }
            return nodes;
        }

        public static XmlElement IncludeFile(string asset, ContentManager content)
        {
            XmlDocument loadDoc = content.Load<XmlDocument>(asset);

            foreach (XmlNode element in loadDoc.ChildNodes)
            {
                if (!(element is XmlElement))
                    continue;

                foreach (XmlNode n2 in element.ChildNodes)
                {
                    if (!(n2 is XmlElement))
                        continue;
                    return n2 as XmlElement;
                }
            }
            return null;
        }

        public static XmlElement IncludeFile(string file)
        {
            XmlDocument loadDoc = new XmlDocument();
            loadDoc.Load(file);

            foreach (XmlNode element in loadDoc.ChildNodes)
            {
                if (!(element is XmlElement))
                    continue;

                foreach (XmlNode n2 in element.ChildNodes)
                {
                    if (!(n2 is XmlElement))
                        continue;
                    return n2 as XmlElement;

                }
            }
            return null;
        }
        
        public static void LoadUsingReflection(NodeList targetList, XmlNodeList xmlNodes)
        {
            foreach (XmlNode xmlNode in xmlNodes)
            {
                XmlElement element = xmlNode as XmlElement;

                // Not an element or doesn't have a Name attribute, then ignore this element
                if (element == null || !element.HasAttribute("Name"))
                    continue;

                SceneNode node;

                // If we cant instantiate the node, then continue to next xml element
                if (!NodeReflector.TryInstantiate(element.Name, element.Attributes["Name"].Value, out node))
                    continue;

                // Set the Properties of this node from using the XML
                node.SetFromXml(element);

                // Put it in our list
                targetList.Add(node);
            }
        }


        public static SceneNode LoadUsingReflection(SceneNode parent, XmlElement element, string file, ContentManager content)
        {
            foreach (Type t in NodeReflector.GetNodeTypes())
            {
                if (t.Name == element.Name)
                {
                    // if already exists in parent
                    //   if has include
                    //     include the file  
                    SceneNode currentNode = null;

                    if (parent != null && parent.ChildNodes.Contains(element.Attributes["Name"].Value))
                    {
                        currentNode = parent.ChildNodes[element.Attributes["Name"].Value];
                    }


                    if(currentNode == null)
                    {
                        currentNode = NodeReflector.InstanciateNode(t, element.Attributes["Name"].Value) as SceneNode; //t.GetConstructor(new Type[] { typeof(string) }).Invoke(new object[] { element.Attributes["Name"].Value }) as SceneNode;
                        if (currentNode == null)
                            return null;
                        if(parent != null)
                            parent.ChildNodes.Add(currentNode);
                    }
                    
                    if (element.HasAttribute("Include") && !string.IsNullOrEmpty(element.Attributes["Include"].Value))
                    {
                        XmlElement includeElement;
                        string path = Path.IsPathRooted(element.Attributes["Include"].Value) ? element.Attributes["Include"].Value : Path.Combine(Path.GetDirectoryName(file), element.Attributes["Include"].Value);
                        if (content == null)
                        {
                            includeElement = IncludeFile(path);
                        }
                        else
                        {
                            includeElement = IncludeFile(element.Attributes["Include"].Value, content);
                        }
                        currentNode.SetFromXml(includeElement);
                        foreach (XmlNode iNode in includeElement.ChildNodes)
                        {
                            if (iNode is XmlElement)
                            {
                                LoadUsingReflection(currentNode, iNode as XmlElement, path,content);
                            }
                        }
                    }

                    currentNode.SetFromXml(element);
                    if (BeforeNodeChildrenLoaded != null)
                    {
                        NodeLoadEventArgs args = new NodeLoadEventArgs();
                        args.Node = currentNode;
                        BeforeNodeChildrenLoaded(null, args);
                    }

                    foreach (XmlElement cNode in element.ChildNodes)
                    {
                        if (cNode is XmlElement)
                        {
                            LoadUsingReflection(currentNode, cNode,file, content);
                        }
                    }
                    if (NodeLoaded != null)
                    {
                        NodeLoadEventArgs args = new NodeLoadEventArgs();
                        args.Node = currentNode;
                        NodeLoaded(null, args);
                    }
                    return currentNode;
                }
            }
            return null;
        }



    }
}
