
sampler Texture : register(s0);

float4x4 ViewProj : ViewProjection;
float4x4 World : World;
float3 lightPos;
bool useTexture;


struct VSOutput
{
	float4	Position	: POSITION0;
	float2	texCoord		: TEXCOORD0;
	float4	world		: TEXCOORD1;
	float4 Color : COLOR0;
};

struct VSInputVc
{
	float4	Position	: POSITION;
	float4	Color		: COLOR;
};

VSOutput mainVS(float4 Position : POSITION, float2 texCoord : TEXCOORD0, float4	Color : COLOR)
{
	VSOutput output;
	output.world = mul(float4(Position.xyz, 1.0), World);
	output.Position = mul(output.world, ViewProj);
	output.texCoord = texCoord;
	output.Color = Color;
	return output;
}

float4 mainPS(VSOutput input) : COLOR 
{
	float c = clamp((1.0 - distance(input.world, lightPos) / 25.0), 1, 1) ;
	float4 r = input.Color * c;
	if(useTexture)
		r *= tex2D(Texture, input.texCoord);
	return r;
}

float4 gahPS(VSOutput input) : COLOR 
{
	return tex2D(Texture, input.texCoord);
}


float4 blackVS(float4 Position : POSITION) : POSITION
{
	return mul(mul(float4(Position.xyz, 1.0), World), ViewProj);
}

float4 blackPS(VSOutput input) : COLOR 
{
	return 0;
}

technique attenuation {
	pass p0 {
		CullMode = CCW;
		VertexShader = compile vs_2_0 mainVS();
		PixelShader = compile ps_2_0 gahPS();
	}
}

technique black {
	pass p0 {
		CullMode = None;
		VertexShader = compile vs_2_0 blackVS();
		PixelShader = compile ps_2_0 blackPS();
	}
}
