/*

% Description of my shader.
% Second line of description for my shader.

keywords: material classic

date: YYMMDD

*/

float4 Color;
float4x4 WorldViewProj : WorldViewProjection;

struct VSOutput
{
	float4	PositionPS	: POSITION;		// Position in projection space
	float4	Diffuse		: COLOR0;
};

struct VSInputVc
{
	float4	Position	: POSITION;
	float4	Color		: COLOR;
};

VSOutput mainVS(VSInputVc vc)
{
	VSOutput output;
	output.PositionPS = mul(float4(vc.Position.xyz, 1.0), WorldViewProj);
	output.Diffuse = vc.Color;
	return output;
}

float4 mainPS(VSOutput input) : COLOR {
	
	return input.Diffuse * Color;
}

technique technique0 {
	pass p0 {
		CullMode = None;
		VertexShader = compile vs_3_0 mainVS();
		PixelShader = compile ps_3_0 mainPS();
	}
}
