using Microsoft.Xna.Framework.Graphics;
using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Input;
public class CrashDebugGame : Game
{
    private SpriteBatch spriteBatch;
    private SpriteFont font;
    private readonly Exception exception;

    public CrashDebugGame(Exception exception)
    {
        this.exception = exception;
        new GraphicsDeviceManager(this);
        Content.RootDirectory = "Content";
    }

    protected override void LoadContent()
    {
        font = Content.Load<SpriteFont>(@"HUD\error");
        spriteBatch = new SpriteBatch(GraphicsDevice);
    }

    protected override void Update(GameTime gameTime)
    {
        if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed || Keyboard.GetState().IsKeyDown(Keys.Escape))
            Exit();

        base.Update(gameTime);
    }

    protected override void Draw(GameTime gameTime)
    {
        GraphicsDevice.Clear(Color.CornflowerBlue);

        spriteBatch.Begin();
        spriteBatch.DrawString(
           font,
           "**** CORNFLOWERBLUE SCREEN OF DEATH ****",
           new Vector2(10f, 10f),
           Color.White);

        spriteBatch.DrawString(
           font,
           string.Format("Exception: {0}", exception.Message),
           new Vector2(10f, 40f),
           Color.White);
        spriteBatch.DrawString(
           font, string.Format("Stack Trace:\n{0}", exception.StackTrace),
           new Vector2(10f, 70f),
           Color.White);
        spriteBatch.End();

        base.Draw(gameTime);
    }
}