﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using GameEngine.Physics;
using Microsoft.Xna.Framework;
using GameEngine.Helpers;

namespace GamePrototype.GameLogic
{


    public class TraceEmitter : ParticleSystem
    {
        public static readonly float SPEED = 5f;
        public static readonly int DURATION = 2000;
        
        public TraceEmitter(int maxParticles) : base(maxParticles)
        {
        }

        public void Trace(CollisionRay ray, float height, float t)
        {
            ParticleSystemParticle p = GetFreeParticle();

            if (p != null)
            {
                p.Direction = new Vector3(ray.Direction.X, 0, ray.Direction.Y);
                p.Position = new Vector3(ray.Position.X, height, ray.Position.Y);
                // m / s = speed 
                p.MaxLifeTime = (int)(t / (float)SPEED);
                p.Speed = SPEED;    
            }            
        }

    }
}
