﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using GameEngine.Xml;
using Microsoft.Xna.Framework;
using GameEngine;

namespace Platformer
{
    public class NewYearBear : DynamicCircleNode
    {
        private const float GRAVITY = 0.1f;
        private const float MOVING_SPEED = 50f;
        private Vector2 movement;
        public float Direction = 0;
        public StarThrower StarThrower { get; set; }

        public NewYearBear(string name) : base(name)
        {
            movement = Vector2.Zero;
            Direction = GoLeft() ? 1 : -1;

            this.StarThrower = new StarThrower(this.Position);
            this.StarThrower.OnFire = true;
        }

        public void Update(GameTime gameTime)
        {
            movement.Y += gameTime.ElapsedGameTime.Milliseconds * GRAVITY;
            movement.Y = MathHelper.Clamp(movement.Y, -10f, 10f);

            movement.X = Direction * gameTime.ElapsedSeconds() * MOVING_SPEED;

            Rotation = Quaternion.CreateFromYawPitchRoll(MathHelper.PiOver2, Direction < 0 ? MathHelper.Pi : 0, -MathHelper.PiOver2);

            this.Position.X += movement.X;
            this.Position.Z += movement.Y;

            if (oldResolve.X * Direction < -0.1f)
            {
                Direction *= -1;        
            }
        }

        private bool GoLeft()
        {
            return Util.Random.Next(2) != 1;
        }
    }
}
