﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using GameEngine.Physics;
using GameEngine;

namespace Platformer
{
    public class StarThrower : ParticleSystem
    {
        private const float SPEED = 0.25f;
        private const int DURATION = 350;
        private const int MAX_PARTICLES = 40;

        public Vector3 Position;
        public bool OnFire = false;

        public StarThrower(Vector3 position) : base(MAX_PARTICLES)
        {
            this.Position = position;
        }

        public override void Update(GameTime gameTime)
        {
            int n = Util.Random.Next(1, 4);

            for (int i = 0; i < n; i++)
            {
                ParticleSystemParticle p = GetFreeParticle();

                if (p != null)
                {
                    p.Position = this.Position;
                    p.MaxLifeTime = DURATION;
                    p.Speed = SPEED * ((float)Util.Random.NextDouble() * 0.5f);

                    p.Direction = new Vector3((float)Util.Random.NextDouble() - 0.5f,
                                              (float)Util.Random.NextDouble() - 0.5f,
                                              (float)Util.Random.NextDouble() - 0.5f);
                }
            }

            base.Update(gameTime);
        }
    }
}
