﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework;
using GameEngine.Physics;
using GameEngine;

namespace Platformer
{
    public class StarThrowerManager
    {
        private readonly Color STARTHROWER_COLOR = Color.Wheat;
        private const int MIN_LENGTH = 5;
        private const int MAX_LENGTH = 10;
        
        public List<StarThrower> StarThrowers { get; set; }
        private ParticleRenderer particleRenderer; 

        public StarThrowerManager()
        {
            StarThrowers = new List<StarThrower>();
        }

        public void Load(ContentManager content, GraphicsDevice graphics)
        {
            particleRenderer = new ParticleRenderer();
            particleRenderer.Load(content, graphics);
        }

        public void Update(GameTime gameTime)
        {
            for (int i = 0; i < StarThrowers.Count; i++)
            {
                if (StarThrowers[i].OnFire)
                {
                    StarThrowers[i].Update(gameTime);
                }
            }
        }

        public void Draw(DrawInfo di)
        {
            for (int i = 0; i < StarThrowers.Count; i++)
            {
                if (StarThrowers[i].OnFire)
                {
                    float intensity = 0;// Util.Random.Next(15) != 5 ? 0f : 0.5f;
                    particleRenderer.DrawAsLines(di, StarThrowers[i], STARTHROWER_COLOR, Util.Random.Next(MIN_LENGTH, MAX_LENGTH + 1), intensity); 
                }
            }
        }
    }
}
