using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using System.Windows.Forms;

namespace XNBContentCompiler
{
    class CompilerDevice : IDisposable
    {
        GraphicsDeviceService graphicsDeviceService;
        Form gfxForm;

        public GraphicsDevice GraphicsDevice
        {
            get { return graphicsDeviceService.GraphicsDevice; }
        }

        public ServiceContainer Services
        {
            get { return services; }
        }

        ServiceContainer services = new ServiceContainer();




        public CompilerDevice()
        {
            gfxForm = new Form();
            graphicsDeviceService = GraphicsDeviceService.AddRef(gfxForm.Handle,
                                                          512,512);

            // Register the service, so components like ContentManager can find it.
            services.AddService<IGraphicsDeviceService>(graphicsDeviceService);
        }

        public void Dispose()
        {
            if (graphicsDeviceService != null)
            {
                graphicsDeviceService.Release(true);
                graphicsDeviceService = null;
                gfxForm = null;
            }
        }
    }
}
